<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable
                      class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search"
                       class="filter-item">搜索
            </el-button>
            <el-button @click="addRow" type="primary" icon="el-icon-plus"
                       class="filter-item">添加
            </el-button>
            <el-button @click="download" type="primary" icon="el-icon-download"
                       :loading="downloading" class="filter-item">导出EXCEL
            </el-button>
        </div>
        <el-table :data="tableData" row-key="id" ref="table"
                  header-row-class-name="table-header-row"
                  header-cell-class-name="table-header-cell"
                  row-class-name="table-row" cell-class-name="table-cell"
                  :height="tableHeight">
            <el-table-column v-if="multipleMode" align="center" type="selection"
                             width="50">
            </el-table-column>
            <el-table-column prop="id" label="ID" width="100">
            </el-table-column>
            <el-table-column prop="user.nickname" label="昵称"
            >
            </el-table-column>
            <el-table-column label="头像" min-width="100">
                <template slot-scope="{row}">
                    <el-image style="width: 30px; height: 30px"
                              :src="row.user.avatar" fit="cover"
                              :preview-src-list="[row.user.avatar]"></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="user.phone" label="手机"
            >
            </el-table-column>
            <el-table-column prop="jobNumber" label="工号"
            >
            </el-table-column>
            <el-table-column prop="area" label="区域"
            >
            </el-table-column>
            <!--                    <el-table-column prop="signIn" label="签到"
            >
                                        <template slot-scope="{row}">
                                            <el-tag :type="row.signIn?'':'info'">{{row.signIn}}</el-tag>
                                        </template>
                                </el-table-column>-->
            <!--                    <el-table-column prop="area" label="工作地点"
            >
                                </el-table-column>-->
            <el-table-column prop="transportation" label="交通工具">
            </el-table-column>
            <el-table-column prop="transportationImg" label="交通工具图片"
            >
                <template slot-scope="{row}">
                    <el-image style="width: 30px; height: 30px"
                              :src="row.transportationImg" fit="cover"
                              :preview-src-list="[row.transportationImg]"></el-image>
                </template>
            </el-table-column>

            <el-table-column prop="driverLicenseImg" label="驾照照片"
            >
                <template slot-scope="{row}">
                    <el-image style="width: 30px; height: 30px"
                              :src="row.driverLicenseImg" fit="cover"
                              :preview-src-list="[row.driverLicenseImg]"></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="status" label="状态"
            >
            </el-table-column>
            <!--                    <el-table-column prop="goodReview" label="好评数"
            >
                                </el-table-column>
                                <el-table-column prop="badReview" label="差评数"
            >
                                </el-table-column>
                                <el-table-column prop="operate" label="操作"
            >
                                </el-table-column>-->
            <!--                    <el-table-column prop="blacklist" label="黑名单"
            >
                                        <template slot-scope="{row}">
                                            <el-tag :type="row.blacklist?'':'info'">{{row.blacklist}}</el-tag>
                                        </template>
                                </el-table-column>-->
            <el-table-column
                    label="操作"
                    align="center"
                    fixed="right"
                    min-width="200">
                <template slot-scope="{row}">
                    <el-button @click="editRow(row)" type="primary" size="mini" plain>详情</el-button>
                    <!--<el-button @click="deleteRow(row)" type="danger" size="mini" plain>删除</el-button>-->
                    <el-button
                            v-if="row.status === 'PENDING'"
                            :loading="row.loading"
                            @click="audit(row, true)"
                            type="warning"
                            size="mini"
                            plain
                    >通过
                    </el-button
                    >
                    <el-button
                            v-if="row.status === 'PENDING'"
                            @click="deny(row)"
                            type="danger"
                            size="mini"
                            plain
                    >拒绝
                    </el-button
                    >
                    <el-button @click="showAppraisal(row)" type="success" size="mini" plain v-if="row.status==='PASS'">评价</el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <!-- <div class="multiple-mode-wrapper">
                <el-button v-if="!multipleMode" @click="toggleMultipleMode(true)">批量编辑</el-button>
                <el-button-group v-else>
                    <el-button @click="operation1">批量操作1</el-button>
                    <el-button @click="operation2">批量操作2</el-button>
                    <el-button @click="toggleMultipleMode(false)">取消</el-button>
                </el-button-group>
            </div> -->
            <el-pagination background @size-change="onSizeChange"
                           @current-change="onCurrentChange" :current-page="page"
                           :page-sizes="[10, 20, 30, 40, 50]" :page-size="pageSize"
                           layout="total, sizes, prev, pager, next, jumper"
                           :total="totalElements">
            </el-pagination>
        </div>

    </div>
</template>
<script>
    import {mapState} from "vuex";
    import pageableTable from "@/mixins/pageableTable";

    export default {
        name: 'RiderList',
        mixins: [pageableTable],
        created() {
            this.getData();
        },
        data() {
            return {
                multipleMode: false,
                search: "",
                url: "/rider/all",
                downloading: false,
            }
        },
        computed: {
            selection() {
                return this.$refs.table.selection.map(i => i.id);
            }
        },
        methods: {
            beforeGetData() {
                if (this.search) {
                    return {search: this.search};
                }
            },
            toggleMultipleMode(multipleMode) {
                this.multipleMode = multipleMode;
                if (!multipleMode) {
                    this.$refs.table.clearSelection();
                }
            },
            addRow() {
                this.$router.push({
                    path: "/riderEdit",
                    query: {
                        ...this.$route.query
                    }
                });
            },
            editRow(row) {
                this.$router.push({
                    path: "/riderEdit",
                    query: {
                        id: row.id
                    }
                });
            },
            download() {
                this.downloading = true;
                this.$axios
                    .get("/rider/excel", {
                        responseType: "blob",
                        params: {size: 10000}
                    })
                    .then(res => {
                        console.log(res);
                        this.downloading = false;
                        const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                        const link = document.createElement("a");
                        link.href = downloadUrl;
                        link.setAttribute(
                            "download",
                            res.headers["content-disposition"].split("filename=")[1]
                        );
                        document.body.appendChild(link);
                        link.click();
                        link.remove();
                    })
                    .catch(e => {
                        console.log(e);
                        this.downloading = false;
                        this.$message.error(e.error);
                    });
            },
            operation1() {
                this.$notify({
                    title: '提示',
                    message: this.selection
                });
            },
            operation2() {
                this.$message('操作2');
            },
            deleteRow(row) {
                this.$alert('删除将无法恢复，确认要删除么？', '警告', {type: 'error'}).then(() => {
                    return this.$http.post(`/rider/del/${row.id}`)
                }).then(() => {
                    this.$message.success('删除成功');
                    this.getData();
                }).catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('删除取消');
                    } else {
                        this.$message.error('删除失败');
                    }
                })
            },
            audit(row, pass) {
                this.$set(row, 'loading', true);
                this.$http
                    .get('/rider/audit', {
                        id: row.id,
                        pass: pass
                    })
                    .then(res => {
                        this.$set(row, 'loading', false);
                        this.$message.success('OK');
                        this.getData();
                    })
                    .catch(e => {
                        console.log(e);
                        this.$set(row, 'loading', false);
                        this.$message.error(e.error);
                    });
            },
            deny(row) {
                this.$prompt('请输入理由', '提示', {
                    inputType: 'textarea'
                })
                    .then(res => {
                        // console.log(res);
                        if (res.value) {
                            this.$alert('确定拒绝通过？', '提示', {
                                showCancelButton: true
                            })
                                .then(() => {
                                    return this.$http.get('/rider/audit', {
                                        id: row.id,
                                        pass: false,
                                        reason: res.value
                                    });
                                })
                                .then(res => {
                                    this.$message.success('成功');
                                    this.$router.go(0);
                                })
                                .catch(() => {
                                    this.$message.error(res.error || '失败');
                                });
                        }
                    })
                    .catch(() => {
                    });
            },
            showAppraisal(row) {
                this.$router.push({
                    path: "/appraisalRidList",
                    query: {
                        rid: row.id
                    }
                });
            },
        }
    }
</script>
<style lang="less" scoped>
</style>
